class disney.rabbitRivalry.ui.UI
{
   var engine;
   var __nextScreenID;
   var __hasActiveScreen;
   var __doesActiveScreenUpdate;
   var __hasIntroPlayed;
   var __activeScreen;
   var __previousScreenID;
   var __activeScreenID;
   static var __instance;
   function UI()
   {
   }
   static function init()
   {
      disney.rabbitRivalry.ui.UI.__instance = new disney.rabbitRivalry.ui.UI();
   }
   static function getInstance()
   {
      return disney.rabbitRivalry.ui.UI.__instance;
   }
   function linkEngine(t_engine)
   {
      this.engine = t_engine;
      smashing.keithm.Messenger.registerAddress("ui",this);
   }
   function reset()
   {
      this.__nextScreenID = "";
      this.__hasActiveScreen = false;
      this.__doesActiveScreenUpdate = false;
      this.__hasIntroPlayed = false;
   }
   function update(dt)
   {
      if(this.__doesActiveScreenUpdate)
      {
         this.__activeScreen.update(dt);
      }
   }
   function returnToPreviousScreen()
   {
      this.__nextScreenID = this.__previousScreenID;
      this.__activeScreen.close();
   }
   function goScreen(id)
   {
      if(this.__hasActiveScreen)
      {
         this.__nextScreenID = id;
         this.__activeScreen.close();
      }
      else
      {
         this.openScreen(id);
      }
   }
   function openScreen(id)
   {
      if(id == undefined)
      {
         id = this.__nextScreenID;
      }
      if(id == "")
      {
         return undefined;
      }
      this.__nextScreenID = "";
      this.__previousScreenID = this.__activeScreenID;
      this.__activeScreenID = id;
      this.engine.gotoAndStop(this.__activeScreenID);
      switch(this.__activeScreenID)
      {
         case "splash":
            this.__activeScreen = new disney.rabbitRivalry.ui.Splash(this.engine.screen_mc,this,this.__hasIntroPlayed);
            this.__hasIntroPlayed = true;
            break;
         case "gameplay":
            this.__activeScreen = new disney.rabbitRivalry.ui.GamePlay(this.engine.screen_mc,this,this.engine.overlay_mc,this.engine.nav_mc,this.engine.helpPopup_mc);
            break;
         case "help":
            this.__activeScreen = new disney.rabbitRivalry.ui.Help(this.engine.screen_mc,this);
            break;
         case "winLevel":
            this.__activeScreen = new disney.rabbitRivalry.ui.WinLevel(this.engine.screen_mc,this);
            break;
         case "winGame":
            this.__activeScreen = new disney.rabbitRivalry.ui.WinGame(this.engine.screen_mc,this);
            break;
         case "gameOver":
            this.__activeScreen = new disney.rabbitRivalry.ui.GameOver(this.engine.screen_mc,this);
            break;
         default:
            trace("[UI] openScreen called with invalid id: " + this.__activeScreenID);
            return undefined;
      }
      this.__activeScreen.init();
      this.__activeScreen.open();
      smashing.keithm.Messenger.registerAddress("screen",this.__activeScreen);
      this.__hasActiveScreen = true;
      this.__doesActiveScreenUpdate = this.__activeScreen.DOES_UPDATE;
   }
   function onScreenClosed()
   {
      if(this.__nextScreenID != "")
      {
         this.openScreen(this.__nextScreenID);
      }
   }
   function disableActiveScreenUpdates()
   {
      this.__doesActiveScreenUpdate = false;
   }
   function enableActiveScreenUpdates()
   {
      this.__doesActiveScreenUpdate = true;
   }
   function onMessageReceived(message, args)
   {
      this[message](args);
   }
   function get currentScreenID()
   {
      return this.__activeScreenID;
   }
}
